//+------------------------------------------------------------------+
//|                                                      Pin_ISB.mq4 |
//|                                                          yijomza |
//|                                                yijomza@gmail.com |
//+------------------------------------------------------------------+
#property copyright "yijomza"
#property link      "yijomza@gmail.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 SkyBlue
#property indicator_color2 Pink

extern color PinBarColor=SkyBlue;
extern color InsideBarColor=Pink;
//---- buffers
double pin[];
double isb[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW,0,3,PinBarColor);
   SetIndexArrow(0,124);
   SetIndexBuffer(0,pin);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW,0,3,InsideBarColor);
   SetIndexArrow(1,124);
   SetIndexBuffer(1,isb);
   SetIndexEmptyValue(1,0.0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   for(int c=5000;c>=1;c--)
   {
      if(insidebar(c))
      {
       if(Close[c]>Open[c])
       {
        isb[c]=Low[c];
       }
       else isb[c]=High[c];
      }
      else
      if(pin(c))
      {
       if(upclose(c))
       {
        pin[c]=Low[c];
       }
       else if(!upclose(c))
       {
        pin[c]=High[c];
       } 
      }
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
bool insidebar(int s)
{
   if(High[s]<=High[s+1] && Low[s]>=Low[s+1])return(true);
   else                                         return(false);
}/**/
bool pin(int s)
{
 double closelow = Close[s]-Low[s];
 double openlow = Open[s]-Low[s];
 double spread = MathAbs(High[s]-Low[s]);
 if(spread==0)spread=Point;
 if (closelow/spread > 0.65 && openlow/spread>0.65){ return(true); }
 else if (closelow/spread < 0.35 && openlow/spread<0.35){ return(true); }
 else return(false);
}
bool upclose(int s)
{
   double closelow = Close[s]-Low[s];
   double openlow = Open[s]-Low[s];
   double spread = MathAbs(High[s]-Low[s]);
   if(spread==0)spread=Point;
   if (closelow/spread > 0.65)return(true);  //{ upclose = true; }
   else if (closelow/spread < 0.35)return(false);  //{ downclose = true; }
}